

// CRC32 2.0.0


// Includes
#include <stdint.h>
#include <string>


// Preprocessor Directives
#pragma once


// Class CRC32 (in Compliance with IEEE 802.3, Polynomial 0x04C11DB7)
class CRC32
{
public:

   // Constructor
   CRC32(void);

   // Compute Checksum
   uint32_t checksum(void);

   // Reset
   void reset(void);

   // Update
   void update(char chr);
   void update(const char* str);
   void update(const char* str, size_t length);
   void update(const std::string& str);

private:

   // Lookup Table
   static const uint32_t _T[];

   // Variables
   uint32_t _checksum;
};
