

// DO02 - OCTAL RELAY MODULE


// Includes
#include "device.hpp"


// Preprocessor Directives
#pragma once


// Class DO02
class DO02 : public Device
{
public:

   // Channels
   static const uint8_t CHANNELS = 8;

   // States
   static const bool STATE_OPEN = false;
   static const bool STATE_CLOSED = true;

   // Constructor
   DO02(const IP::Address& address);
   DO02(const Device& device);

   // Write
   void write(bool state) const;
   void write(uint8_t channel, bool state) const;
   void write(const std::set<uint8_t>& channel, bool state) const;
   void write(const std::map<uint8_t, bool>& state) const;

private:

   // DCP Message Types
   static const uint16_t _MESSAGE_WRITE = 0x0A00;
};
