

// UDP 2.0.1


// Includes
#include <ip.hpp>


// Check Compiler
#ifdef _MSC_BUILD

   // Includes
   #include <ws2tcpip.h>

#endif


// Preprocessor Directives
#pragma once


// Class UDP
class UDP
{
public:

   // Class Exception
   class Exception;

   // Initialize
   static void init(void);

   // Constructor
   UDP(const IP::Address& ip_host = IP::Address(), uint16_t port_host = 0);

   // Destructor
   ~UDP(void);

   // Flush Receive Buffer
   void flush(void) const;

   // Receive Packet with Timeout [ms]
   void receive(IP::Address& ip_source, uint16_t& port_source, std::string& str, uint16_t timeout = 0) const;

   // Send Packet
   void send(const IP::Address& ip_dest, uint16_t port_dest, const std::string& str) const;

private:

   // Copy Constructor
   UDP(const UDP& udp);

   // Receive Buffer Size
   static const uint32_t _BUFFER_SIZE = 65536L;

   // Check Compiler
   #ifdef _MSC_BUILD

      // Variables
      SOCKET _socket;

   #else

      // Variables
      int _socket;

   #endif
};


// Class Exception
class UDP::Exception
{
public:

   // Class Internal
   class Internal;

   // Class Network
   class Network;

   // Class Timeout
   class Timeout;

private:

   // Virtual Function for RTTI
   virtual void _func() {}
};


// Class Internal
class UDP::Exception::Internal : public UDP::Exception
{
};


// Class Network
class UDP::Exception::Network : public UDP::Exception
{
};


// Class Timeout
class UDP::Exception::Timeout : public UDP::Exception
{
};
